/*
	Copyright  2004, Jacek Piszczek. All rights reserved. NOT PART OF APL TREE!!!
	$Id: killtaskbrokers.c,v 1.1.1.1 2005/03/15 15:57:28 laire Exp $
*/

#define AROS_ALMOST_COMPATIBLE

#include "cxintern.h"
#include <libraries/commodities.h>
#include <proto/exec.h>
#include <proto/commodities.h>

AROS_LH1(void, KillTaskBrokers,
		 AROS_LHA(struct Task *,task,A0),
		 struct Library *, CxBase, 40, Commodities)
{
	AROS_LIBFUNC_INIT

	struct Node *node;

	ObtainSemaphore(&GPB(CxBase)->cx_SignalSemaphore);

	node = GetHead(&GPB(CxBase)->cx_BrokerList);

	while (node)
	{
		CxObj *broker = (CxObj *)node;

		node = GetSucc(node);

		if (broker->co_Ext.co_BExt->bext_Task == task)
		{
			DeleteCxObjAll(broker);
		}
	}

	ReleaseSemaphore(&GPB(CxBase)->cx_SignalSemaphore);

	AROS_LIBFUNC_EXIT
}
